diff --git a/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
index d0a4ba07c..ecb2eba00 100644
--- a/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
@@ -1,13 +1,8 @@
 package net.minecraft.core.entity.monster;
 
-// Referenced classes of package net.minecraft.src:
-//            EntityMob, DataWatcher, NBTTagCompound, World, 
-//            SkeletonMob, Item, Entity, LightningEntity
-
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.LightningEntity;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -15,7 +10,8 @@ import net.minecraft.core.world.World;
 
 public class CreeperMob extends Monster
 {
-
+    public static final int DATA_CREEPER_STATE = 16;
+    public static final int DATA_POWERED = 17;
     public CreeperMob(World world)
     {
         super(world);
@@ -29,15 +25,15 @@ public class CreeperMob extends Monster
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, (byte) -1);
-        entityData.define(17, (byte) 0);
+        entityData.define(DATA_CREEPER_STATE, (byte) -1, Byte.class);
+        entityData.define(DATA_POWERED, (byte) 0, Byte.class);
     }
 
     @Override
 	public void addAdditionalSaveData(CompoundTag tag)
     {
         super.addAdditionalSaveData(tag);
-        if(entityData.getByte(17) == 1)
+        if(entityData.getByte(DATA_POWERED) == 1)
         {
             tag.putBoolean("powered", true);
         }
@@ -47,7 +43,7 @@ public class CreeperMob extends Monster
 	public void readAdditionalSaveData(CompoundTag tag)
     {
         super.readAdditionalSaveData(tag);
-        entityData.set(17, (byte) (tag.getBoolean("powered") ? 1 : 0));
+        entityData.set(DATA_POWERED, (byte) (tag.getBoolean("powered") ? 1 : 0));
     }
 
     @Override
@@ -160,7 +156,7 @@ public class CreeperMob extends Monster
 
     public boolean getPowered()
     {
-        return entityData.getByte(17) == 1;
+        return entityData.getByte(DATA_POWERED) == 1;
     }
 
     public float getSwelling(float partialTick)
@@ -170,19 +166,19 @@ public class CreeperMob extends Monster
 
     private int getCreeperState()
     {
-        return entityData.getByte(16);
+        return entityData.getByte(DATA_CREEPER_STATE);
     }
 
     private void setCreeperState(int i)
     {
-        entityData.set(16, Byte.valueOf((byte)i));
+        entityData.set(DATA_CREEPER_STATE, (byte) i);
     }
 
     @Override
 	public void thunderHit(LightningEntity bolt)
     {
         super.thunderHit(bolt);
-        entityData.set(17, Byte.valueOf((byte)1));
+        entityData.set(DATA_POWERED, (byte) 1);
     }
 
     int timeSinceIgnited;
diff --git a/src/main/java/net/minecraft/core/entity/monster/GhastMob.java b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
index b7d47da47..1a3f1c49f 100644
--- a/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
@@ -21,6 +21,7 @@ import net.minecraft.core.util.helper.DamageType;
 public class GhastMob extends FlyingMob
     implements Enemy
 {
+    public static final int DATA_CHARGING = 16;
     public int courseChangeCooldown;
     public double waypointX;
     public double waypointY;
@@ -51,13 +52,13 @@ public class GhastMob extends FlyingMob
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, Byte.valueOf((byte)0));
+        entityData.define(DATA_CHARGING, (byte) 0, Byte.class);
     }
 
     @Override
     public String getEntityTexture()
     {
-        if (entityData.getByte(16) != 1)
+        if (entityData.getByte(DATA_CHARGING) != 1)
         {
             return super.getEntityTexture();
         }
@@ -70,7 +71,7 @@ public class GhastMob extends FlyingMob
     @Override
     public String getDefaultEntityTexture()
     {
-        if (entityData.getByte(16) != 1)
+        if (entityData.getByte(DATA_CHARGING) != 1)
         {
             return super.getEntityTexture();
         }
@@ -85,7 +86,7 @@ public class GhastMob extends FlyingMob
         //prevAttackCounter = attackCounter; -uncomment if it still doesn't work
         if(world.isClientSide)
         {
-            byte i = entityData.getByte(16);
+            byte i = entityData.getByte(DATA_CHARGING);
             if(i > 0 && attackCharge == 0)
             {
                 world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
@@ -203,11 +204,11 @@ public class GhastMob extends FlyingMob
         }
         if(!world.isClientSide)
         {
-            byte byte0 = entityData.getByte(16);
-            byte byte1 = (byte)(attackCharge <= 10 ? 0 : 1);
-            if(byte0 != byte1)
+            byte chargeData = entityData.getByte(DATA_CHARGING);
+            byte chargeState = (byte)(attackCharge <= 10 ? 0 : 1);
+            if(chargeData != chargeState)
             {
-                entityData.set(16, Byte.valueOf(byte1));
+                entityData.set(DATA_CHARGING, chargeState);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java b/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
index 988535c6b..fdbd71f39 100644
--- a/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.World;
 
 public class ScorpionMob extends Monster
 {
+    public static final int DATA_UNKNOWN = 16; // No clue why this exists
 
     public ScorpionMob(World world)
     {
@@ -30,7 +31,7 @@ public class ScorpionMob extends Monster
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, (byte) 1);
+        entityData.define(DATA_UNKNOWN, (byte) 1, Byte.class);
 
     }
     @Override
diff --git a/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
index 006930fd6..a1981b76b 100644
--- a/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
@@ -17,6 +17,7 @@ import net.minecraft.core.world.weather.Weathers;
 
 public class SkeletonMob extends Monster
 {
+    public static final int DATA_ATTACK_TIME = 15;
 
     public SkeletonMob(World world)
     {
@@ -48,16 +49,16 @@ public class SkeletonMob extends Monster
     protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(15, attackTime);
+        entityData.define(DATA_ATTACK_TIME, attackTime, Integer.class);
     }
 
     @Override
 	public void onLivingUpdate()
     {
         if (world.isClientSide){
-            attackTime = entityData.getInt(15);
+            attackTime = entityData.getInt(DATA_ATTACK_TIME);
         } else {
-            entityData.set(15, attackTime);
+            entityData.set(DATA_ATTACK_TIME, attackTime);
         }
         if(world.isDaytime())
         {
diff --git a/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java b/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
index da9858725..57b604f42 100644
--- a/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
@@ -21,6 +21,7 @@ import java.util.List;
 public class SlimeMob extends Mob
     implements Enemy
 {
+    public static final int DATA_SLIME_SIZE = 16;
 
     public SlimeMob(World world)
     {
@@ -49,7 +50,7 @@ public class SlimeMob extends Mob
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, (byte) 1);
+        entityData.define(DATA_SLIME_SIZE, (byte) 1, Byte.class);
     }
 
     @Override
@@ -66,7 +67,7 @@ public class SlimeMob extends Mob
 
     public void setSlimeSize(int i)
     {
-        entityData.set(16, (byte) i);
+        entityData.set(DATA_SLIME_SIZE, (byte) i);
         setSize(0.5F * (float)i, 0.5F * (float)i);
         setHealthRaw(getMaxHealth());
         setPos(x, y, z);
@@ -78,7 +79,7 @@ public class SlimeMob extends Mob
 
     public int getSlimeSize()
     {
-        return entityData.getByte(16);
+        return entityData.getByte(DATA_SLIME_SIZE);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/entity/monster/SpiderMob.java b/src/main/java/net/minecraft/core/entity/monster/SpiderMob.java
index 46c39cdbd..6173d85d3 100644
--- a/src/main/java/net/minecraft/core/entity/monster/SpiderMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SpiderMob.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.World;
 
 public class SpiderMob extends Monster
 {
+    public static final int DATA_UNKNOWN = 16; // No clue why this exists
 
     public SpiderMob(World world)
     {
@@ -30,8 +31,7 @@ public class SpiderMob extends Monster
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, (byte) 1);
-
+        entityData.define(DATA_UNKNOWN, (byte) 1, Byte.class);
     }
     @Override
 	public void spawnInit()
diff --git a/src/main/java/net/minecraft/core/entity/monster/ZombieArmoredMob.java b/src/main/java/net/minecraft/core/entity/monster/ZombieArmoredMob.java
index 1ca4a8999..94b97e7be 100644
--- a/src/main/java/net/minecraft/core/entity/monster/ZombieArmoredMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/ZombieArmoredMob.java
@@ -4,6 +4,7 @@ package net.minecraft.core.entity.monster;
 //            EntityMob, World, MathHelper, Item
 
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.item.Items;
@@ -18,11 +19,20 @@ import java.util.Random;
 
 public class ZombieArmoredMob extends ZombieMob
 {
-    private boolean isHoldingSword;
+    public static final int DATA_BREAK_POINTS = 6;
+    public static final int DATA_BREAK_ORDER = 7;
+    public static final int DATA_GENERIC_FLAGS = 8;
+    public static final int MASK_FLAG_SWORD = 0b0000_0001;
     public ZombieArmoredMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "zombie_armored");
+        scoreValue = 1000;
+    }
+
+    @Override
+    public void spawnInit() {
+        super.spawnInit();
         Random rand = new Random();
         setHoldingSword(rand.nextInt(5)==0);
         List<Integer> armorItems = new ArrayList<>();
@@ -44,12 +54,13 @@ public class ZombieArmoredMob extends ZombieMob
             armorBreakPoints[i] = 30 - (10 * i) + rand.nextInt(10);
         }
         setArmorBreakPoints(armorBreakPoints);
-        scoreValue = 1000;
     }
+
     @Override
     public void defineSynchedData(){
-        entityData.define(6, Integer.valueOf(0));
-        entityData.define(7, Short.valueOf((short) 0));
+        entityData.define(DATA_BREAK_POINTS, 0, Integer.class);
+        entityData.define(DATA_BREAK_ORDER, (short) 0, Short.class);
+        entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
     }
     @Override
     public int getMaxHealth(){
@@ -108,14 +119,46 @@ public class ZombieArmoredMob extends ZombieMob
         return new int[]{value & 0x3, (value & 0xC) >> 2, (value & 0x30) >> 4, (value & 0xC0) >> 6};
     }
     public void setHoldingSword(boolean flag){
-        isHoldingSword = flag;
-        attackStrength = isHoldingSword? 7:5;
+        if (flag) {
+            entityData.set(DATA_GENERIC_FLAGS, (byte)(entityData.getByte(DATA_GENERIC_FLAGS) | MASK_FLAG_SWORD));
+            attackStrength = 7;
+        } else {
+            entityData.set(DATA_GENERIC_FLAGS, (byte)(entityData.getByte(DATA_GENERIC_FLAGS) & ~ MASK_FLAG_SWORD));
+            attackStrength = 5;
+        }
+    }
+
+    public boolean isHoldingSword() {
+        byte data = entityData.getByte(DATA_GENERIC_FLAGS);
+        return (data & MASK_FLAG_SWORD) != 0;
+    }
+
+    @Override
+    public void addAdditionalSaveData(CompoundTag tag) {
+        super.addAdditionalSaveData(tag);
+        tag.putInt("breakpoints", entityData.getInt(DATA_BREAK_POINTS));
+        tag.putShort("breakorder", entityData.getShort(DATA_BREAK_ORDER));
+        tag.putBoolean("hasSword", isHoldingSword());
+    }
+
+    @Override
+    public void readAdditionalSaveData(CompoundTag tag) {
+        super.readAdditionalSaveData(tag);
+        if (tag.containsKey("breakpoints")) {
+            entityData.set(DATA_BREAK_POINTS, tag.getInteger("breakpoints"));
+        }
+        if (tag.containsKey("breakorder")) {
+            entityData.set(DATA_BREAK_ORDER, tag.getShort("breakorder"));
+        }
+        if (tag.containsKey("hasSword")) {
+            setHoldingSword(tag.getBoolean("hasSword"));
+        }
     }
 
     @Override
 	public ItemStack getHeldItem()
     {
-        if(this.isHoldingSword)
+        if(this.isHoldingSword())
             return defaultHeldItem;
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index af732e9aa..0c3bf9202 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -76,6 +76,9 @@ import java.util.UUID;
 
 public abstract class Player extends Mob
 {
+    public static final int DATA_UNKNOWN = 16; // I have no idea wtf this id is for
+    public static final int DATA_SELECTED_ART = 17;
+    public static final int DATA_HELD_ARROW = 18;
     public static final TextFormatting deathMsgColor = TextFormatting.RED;
     public Inventory inventory;
     public AbstractContainerMenu inventorySlots;
@@ -151,12 +154,12 @@ public abstract class Player extends Mob
 
     public ArtType getSelectedArt()
     {
-        return ArtType.values.get(entityData.getByte(17));
+        return ArtType.values.get(entityData.getByte(DATA_SELECTED_ART));
     }
 
     public void setSelectedArt(ArtType selectedArt)
     {
-        entityData.set(17, (byte)ArtType.values.indexOf(selectedArt));
+        entityData.set(DATA_SELECTED_ART, (byte)ArtType.values.indexOf(selectedArt));
     }
 
     private void setupDwarfMode() {
@@ -182,9 +185,9 @@ public abstract class Player extends Mob
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(16, (byte) 0);
-        entityData.define(17, (byte) 0); // selected art
-        entityData.define(18, -1);
+        entityData.define(DATA_UNKNOWN, (byte) 0, Byte.class);
+        entityData.define(DATA_SELECTED_ART, (byte) 0, Byte.class); // selected art
+        entityData.define(DATA_HELD_ARROW, -1, Integer.class);
     }
 
     @Override
@@ -1616,7 +1619,7 @@ public abstract class Player extends Mob
         return nextArrow;
     }
     public int getArrowId(){
-        return entityData.getInt(18);
+        return entityData.getInt(DATA_HELD_ARROW);
     }
     public boolean hasItem(Item item){
         for (ItemStack stack : this.inventory.mainInventory) {
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 934ca02ee..c7d77846d 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -19,6 +19,7 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
@@ -79,6 +80,7 @@ public class MinecartEntity extends Entity implements Container {
     public int hurtDirection;
     public boolean flipped;
     public int type;
+    public int typeMeta; // Just used for chest color *for now*
     public int fuel;
     public double xPush;
     public double zPush;
@@ -699,6 +701,11 @@ public class MinecartEntity extends Entity implements Container {
                     if (carriedBlock.entity instanceof ChestBlockEntity) {
                         ChestBlockEntity chest = (ChestBlockEntity) carriedBlock.entity;
                         this.type = CHEST_CART;
+                        if (carriedBlock.block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
+                            this.typeMeta = carriedBlock.metadata & 0b1111_0000 | 0b0000_0001;
+                        } else {
+                            this.typeMeta = carriedBlock.metadata & 0b1111_0000;
+                        }
                         for (int i = 0; i < this.getContainerSize(); i++) {
                             this.setItem(i, chest.getItem(i));
                             chest.setItem(i, null);
@@ -716,16 +723,23 @@ public class MinecartEntity extends Entity implements Container {
                 break;
             case CHEST_CART:
                 if(!world.isClientSide) {
-                    if (player.isSneaking()) {
+                    if (player.isSneaking() && player.getHeldObject() == null) {
                         ChestBlockEntity blockEntity = new ChestBlockEntity();
                         for (int i = 0; i < this.getContainerSize(); i++) {
                             blockEntity.setItem(i, this.getItem(i));
                             this.setItem(i, null);
                         }
                         blockEntity.worldObj = null;
-                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, Blocks.CHEST_PLANKS_OAK, 0);
+                        Block block;
+                        if ((typeMeta & 0b0000_0001) != 0) {
+                            block = Blocks.CHEST_PLANKS_OAK_PAINTED;
+                        } else {
+                            block = Blocks.CHEST_PLANKS_OAK;
+                        }
+                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, block, typeMeta & 0b1111_0000);
                         player.setHeldObject(blockEntity.carriedBlock);
                         this.type = PASSENGER_CART;
+                        this.typeMeta = 0;
                     } else {
                         player.displayContainerScreen(this);
                     }
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index 1e3435b56..d0c3c689b 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -149,7 +149,7 @@ public class Explosion {
         int z1 = MathHelper.floor(explosionZ - (double) explosionSize2 - 1.0D);
         int z2 = MathHelper.floor(explosionZ + (double) explosionSize2 + 1.0D);
         
-        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getTemporaryBB(x1, y1, z1, x2, y2, z2));
+        List<Entity> list = new ArrayList<>(worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getTemporaryBB(x1, y1, z1, x2, y2, z2)));
         Vec3 vec3 = Vec3.getTempVec3(explosionX, explosionY, explosionZ);
         for (Entity entity : list) {
             double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double) explosionSize2;
diff --git a/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java b/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
index 85fe76d42..f21f66bf3 100644
--- a/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
+++ b/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
@@ -41,11 +41,12 @@ public class SynchedEntityData
      * Attempts to define a new piece of synchronized data.
      * @param id The ID of the data item.
      * @param value The initial value to define for the data item.
+     * @param valueClass The class that value is
      * @param <T> The type of the data item.
      */
-    public <T> void define(int id, T value)
+    public <T> void define(int id, T value, Class<T> valueClass)
     {
-        Integer integer = DATA_TYPES.get(value.getClass());
+        Integer integer = DATA_TYPES.get(valueClass);
         if(integer == null)
         {
             throw new IllegalArgumentException("Unknown data type: " + value.getClass());
@@ -67,36 +68,6 @@ public class SynchedEntityData
         }
     }
 
-    /**
-     * Attempts to define a new piece of synchronized data.
-     * @param id The ID of the data item.
-     * @param valueClass The class to define for the data item, which will default the initial value to null.
-     * @param <T> The type of the data item.
-     */
-    public <T> void define(int id, Class<T> valueClass)
-    {
-        Integer integer = DATA_TYPES.get(valueClass);
-        if(integer == null)
-        {
-            throw new IllegalArgumentException("Unknown data type: " + valueClass);
-        }
-
-        if(id > MAX_DATA_VALUE)
-        {
-            throw new IllegalArgumentException("Data value id is too big with " + id + "! (Max is " + MAX_DATA_VALUE + ")");
-        }
-
-        if(itemsById.containsKey(id))
-        {
-            throw new IllegalArgumentException("Duplicate id value for " + id + "!");
-        }
-        else
-        {
-            DataItem<T> item = new DataItem<>(integer, id, null);
-            itemsById.put(id, item);
-        }
-    }
-
     /**
      * Fetches the value for a specific item as a byte.
      * @param id The item ID.
diff --git a/src/main/java/net/minecraft/datagen/RecipesGenerator.java b/src/main/java/net/minecraft/datagen/RecipesGenerator.java
index c5cbd2fc2..49ce6206b 100644
--- a/src/main/java/net/minecraft/datagen/RecipesGenerator.java
+++ b/src/main/java/net/minecraft/datagen/RecipesGenerator.java
@@ -13,13 +13,44 @@ import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import java.io.File;
 import java.io.FileReader;
 import java.io.IOException;
+import java.nio.file.Files;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
 public class RecipesGenerator {
     private static final boolean DEBUG = false;
     public static final String CORE_NAMESPACE = "minecraft";
-    public static void main(String[] args) {
+    public static void main(String[] args) throws IOException {
+        System.out.println("Generating Recipes with args: ");
+        System.out.println(Arrays.toString(args));
+        String outputPath = null;
+        int pointer = 0;
+        while (pointer < args.length) {
+            switch (args[pointer]) {
+                case "--output": {
+                    try {
+                        outputPath = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                default:
+                    pointer++;
+            }
+        }
+
+        File output;
+        if (outputPath != null) {
+            output = new File(outputPath);
+        } else {
+            output = new File("generated/recipes/");
+        }
+        output.mkdirs();
+
         Blocks.init();
         Items.init();
         new Registries();
@@ -39,7 +70,7 @@ public class RecipesGenerator {
                 }
             }
         }
-        RecipeBuilder.exportRecipes(new File("generated/recipes/workbench.json"), Registries.RECIPES.WORKBENCH);
+        RecipeBuilder.exportRecipes(new File(output, "workbench.json"), Registries.RECIPES.WORKBENCH);
 
         if (DEBUG) System.out.println();
 
@@ -56,7 +87,7 @@ public class RecipesGenerator {
                 }
             }
         }
-        RecipeBuilder.exportRecipes(new File("generated/recipes/furnace.json"), Registries.RECIPES.FURNACE);
+        RecipeBuilder.exportRecipes(new File(output, "furnace.json"), Registries.RECIPES.FURNACE);
 
         if (DEBUG) System.out.println();
 
@@ -72,7 +103,7 @@ public class RecipesGenerator {
                 }
             }
         }
-        RecipeBuilder.exportRecipes(new File("generated/recipes/blast_furnace.json"), Registries.RECIPES.BLAST_FURNACE);
+        RecipeBuilder.exportRecipes(new File(output, "blast_furnace.json"), Registries.RECIPES.BLAST_FURNACE);
 
         if (DEBUG) System.out.println();
 
@@ -89,7 +120,9 @@ public class RecipesGenerator {
                 }
             }
         }
-        RecipeBuilder.exportRecipes(new File("generated/recipes/trommel.json"), Registries.RECIPES.TROMMEL);
+        RecipeBuilder.exportRecipes(new File(output, "trommel.json"), Registries.RECIPES.TROMMEL);
+
+        System.out.println("Finished all " + Registries.RECIPES.getAllRecipes().size() + " recipes!");
     }
 
     public static List<String> getMissingIds(RecipeGroup recipeGroup, File referenceFile) {
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 9b14a591e..63c4c7318 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1271,16 +1271,15 @@ class WorkbenchGenerator {
 
     private static void generateUndyeingRecipes() {
         final String format = "%s_undyeing";
-        final int stackSize = 8;
-
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:planks"), new ItemStack(Blocks.PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "stairs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:stairs_planks"), new ItemStack(Blocks.STAIRS_PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "slabs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:slabs_planks"), new ItemStack(Blocks.SLAB_PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "fences_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fences_planks"), new ItemStack(Blocks.FENCE_PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL, stackSize)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK, stackSize)));
+
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:planks"), new ItemStack(Blocks.PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "stairs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:stairs_planks"), new ItemStack(Blocks.STAIRS_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "slabs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:slabs_planks"), new ItemStack(Blocks.SLAB_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fences_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fences_planks"), new ItemStack(Blocks.FENCE_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
     }
 }
